<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: banner-acl.php 4130 2006-01-26 18:05:33Z andrew@m3.net $
*/

// Require the initialisation file
require_once '../../init.php';

// Required files
require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/www/admin/lib-statistics.inc.php';
require_once MAX_PATH . '/lib/max/other/html.php';
require_once MAX_PATH . '/lib/max/Plugins/Plugins.php';
require_once MAX_PATH . '/lib/max/other/lib-acl.inc.php';

// Register input variables
phpAds_registerGlobal ('cap', 'session_capping', 'time', 'acl', 'action', 'submit');


// Initialise some parameters
$pageName = basename($_SERVER['PHP_SELF']);
$tabindex = 1;
$agencyId = phpAds_getAgencyID();
$aEntities = array('clientid' => $clientid, 'campaignid' => $campaignid, 'bannerid' => $bannerid);

if (!MAX_checkAd($clientid, $campaignid, $bannerid)) {
    phpAds_Die($strAccessDenied, $strNotAdmin);
}

if (!empty($action)) {
    $acl = MAX_AclAdjust($acl, $action);
} elseif (!empty($submit)) {
    $acl = (isset($acl)) ? $acl : array();
    MAX_AclSave($acl, $aEntities);

    // Set time limit
	if (isset($time)) {
		$block = 0;
		if ($time['second'] != '-') $block += (int)$time['second'];
		if ($time['minute'] != '-') $block += (int)$time['minute'] * 60;
		if ($time['hour'] != '-') 	$block += (int)$time['hour'] * 3600;
	} else {
		$block = 0;
	}

	// Set capping and session capping
	if (isset($cap) && $cap != '-') {
		$cap = (int)$cap;
	} else {
		$cap = 0;
	}

	if (isset($session_capping) && $session_capping != '-') {
		$session_capping = (int)$session_capping;
	} else {
		$session_capping = 0;
	}

	$res = phpAds_dbQuery("
		UPDATE
	       {$conf['table']['prefix']}{$conf['table']['banners']}
		SET
			block='{$block}', capping='{$cap}', session_capping='{$session_capping}',
			updated = '".date('Y-m-d H:i:s')."'
		WHERE
			bannerid='{$bannerid}'
	") or phpAds_sqlDie();

    header("Location: banner-zone.php?clientid={$clientid}&campaignid={$campaignid}&bannerid={$bannerid}");
    exit;
}

/*-------------------------------------------------------*/
/* HTML framework                                        */
/*-------------------------------------------------------*/

// Display navigation
$aOtherCampaigns = Admin_DA::getPlacements(array('agency_id' => $agencyId));
$aOtherBanners = Admin_DA::getAds(array('placement_id' => $campaignid), false);
MAX_displayNavigationBanner($pageName, $aOtherCampaigns, $aOtherBanners, $aEntities);

/*-------------------------------------------------------*/
/* Main code                                             */
/*-------------------------------------------------------*/

$aBanner = MAX_getAd($bannerid);
$acl = (isset($acl)) ? $acl : Admin_DA::getDeliveryLimitations(array('ad_id' => $bannerid));

$cap = (isset($cap)) ? $cap : $aBanner['capping'];
$session_capping = (isset($session_capping)) ? $session_capping : $aBanner['session_capping'];

if (!isset($time)) {
    $seconds = $aBanner['block'];

    $time['hour'] = ($seconds - ($seconds % 3600)) / 3600;
    $seconds = $seconds % 3600;

    $time['minute'] = ($seconds - ($seconds % 60)) / 60;
    $seconds = $seconds % 60;

    $time['second'] = $seconds;
}

if ($time['hour'] == 0 && $time['minute'] == 0 && $time['second'] == 0) $time['second'] = '-';
if ($time['hour'] == 0 && $time['minute'] == 0) $time['minute'] = '-';
if ($time['hour'] == 0) $time['hour'] = '-';
if ($cap == 0) $cap = '-';
if ($session_capping == 0) $session_capping = '-';

$aParams = array('clientid' => $clientid, 'campaignid' => $campaignid, 'bannerid' => $bannerid);

MAX_displayAcls($acl, $aParams);

echo "
<table border='0' width='100%' cellpadding='0' cellspacing='0' bgcolor='#FFFFFF'>
<tr><td height='25' colspan='3' bgcolor='#FFFFFF'><b>{$GLOBALS['strDeliveryCapping']}</b></td></tr>
<tr><td height='1' colspan='3' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>
<tr><td height='10' colspan='3'>&nbsp;</td></tr>

<tr><td width='30'>&nbsp;</td>
<td width='200'>{$GLOBALS['strTimeCapping']}</td>
<td valign='top'>
<input id='timehour' class='flat' type='text' size='3' name='time[hour]' value='{$time['hour']}' onKeyUp=\"phpAds_formLimitUpdate(this);\" tabindex='".($tabindex++)."'> {$GLOBALS['strHours']}&nbsp;&nbsp;
<input id='timeminute' class='flat' type='text' size='3' name='time[minute]' value='{$time['minute']}' onKeyUp=\"phpAds_formLimitUpdate(this);\" tabindex='".($tabindex++)."'> ".$strMinutes." &nbsp;&nbsp;
<input id='timesecond' class='flat' type='text' size='3' name='time[second]' value='{$time['second']}' onBlur=\"phpAds_formLimitBlur(this);\" onKeyUp=\"phpAds_formLimitUpdate(this);\" tabindex='".($tabindex++)."'> {$GLOBALS['strSeconds']}&nbsp;&nbsp;
</td></tr>
<tr><td><img src='images/spacer.gif' height='1' width='100%'></td>
<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>

<tr><td width='30'>&nbsp;</td>
<td width='200'>{$GLOBALS['strImpressionCapping']}</td>
<td valign='top'>
<input class='flat' type='text' size='3' name='cap' value='{$cap}' onBlur=\"phpAds_formCapBlur(this);\" tabindex='".($tabindex++)."'> {$GLOBALS['$strTimes']}
</td></tr>

<tr><td><img src='images/spacer.gif' height='1' width='100%'></td>
<td colspan='2'><img src='images/break-l.gif' height='1' width='200' vspace='6'></td></tr>

<tr><td width='30'>&nbsp;</td>
<td width='200'>{$GLOBALS['strImpressionCappingSession']}</td>
<td valign='top'>
<input class='flat' type='text' size='3' name='session_capping' value='{$session_capping}' onBlur=\"phpAds_formCapBlur(this);\" tabindex='".($tabindex++)."'> {$GLOBALS['strTimes']}
</td></tr>

<tr><td height='10' colspan='3'>&nbsp;</td></tr>
<tr><td height='1' colspan='3' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>

</table>

<br /><br /><br />
<input type='submit' name='submit' value='$strSaveChanges' tabindex='".($tabindex++)."'>

</form>
";

/*-------------------------------------------------------*/
/* Form requirements                                     */
/*-------------------------------------------------------*/
?>
<script language='JavaScript'>
<!--

	function phpAds_formCapBlur (i)
	{
		if (i.value == '' || i.value == '0') i.value = '-'
	}

	function phpAds_formLimitBlur (i)
	{
		f = i.form;

		if (f.timehour.value == '') f.timehour.value = '0';
		if (f.timeminute.value == '') f.timeminute.value = '0';
		if (f.timesecond.value == '') f.timesecond.value = '0';

		phpAds_formLimitUpdate (i);
	}

	function phpAds_formLimitUpdate (i)
	{
		f = i.form;

		// Set -
		if (f.timeminute.value == '-' && f.timehour.value != '-') f.timeminute.value = '0';
		if (f.timesecond.value == '-' && f.timeminute.value != '-') f.timesecond.value = '0';

		// Set 0
		if (f.timehour.value == '0') f.timehour.value = '-';
		if (f.timehour.value == '-' && f.timeminute.value == '0') f.timeminute.value = '-';
		if (f.timeminute.value == '-' && f.timesecond.value == '0') f.timesecond.value = '-';
	}

//-->
</script>
<?php

phpAds_PageFooter();

?>
